# -*- coding: utf-8 -*-

import sys
import glob
import os
import traceback

from resource import ResourceList
from config import *

def run_refextract(cmds):
    out_file = cmds[1]
    try:
        print 'RUNNING: python %s %s' % (cmds[0], cmds[2])
        os.system('python %s %s' % (cmds[0], cmds[2]))
        if os.path.exists(out_file):
            return "__DONE: " + out_file
        else:
            return "__FAIL: " + out_file
    except Exception:
        traceback.print_exc(file=sys.stderr)
        return "__FAIL: " + out_file


def main():
    input_files = glob.glob("*" + CFG_INPUT_EXT)
    print input_files
    if len(input_files) > 0:
        rl = ResourceList(input_files[0])

    xml_out = ""
    refextract_commands = []

    ## Get the output file for the job
    for (type, value) in rl:
        if type == ResourceList.RESOURCE and value.output == True:
            xml_out = value.uri
            ## Just a single output file is needed for refextract
            break

    ## Make the series of refextract commands, with the input
    for (type, value) in rl:
        if xml_out == "":
            print "there was no output 'resource object' found with this refextract job"

        ## Has to be placed inside the resourceList iteration (???)
        grid_side_recid_args = rl.get_current_option('arguments')
        if grid_side_recid_args:
            print "Found input resource: %s" % grid_side_recid_args
            refextract_commands.append(('./refextract_package/bin/refextract', xml_out, grid_side_recid_args))
            ## Break when refextract's argument list (recid:file ...) has been obtained
            break

        #if type == ResourceList.RESOURCE and value.input == True:
        #    print "Found input resource: %s" % value.uri
        #    text_in = value.uri
        #    refextract_commands.append(('./refextract_package/bin/refextract', xml_out, text_in))

    ## Map the refextract process call onto each of the refextract system commands 
    all_cmd_results = map(run_refextract,refextract_commands)

    ## Place on stderr, the results of running refextract on each of the tuple of arguments
    for i, a_single_cmd_result in enumerate(all_cmd_results):
        print "all_cmd_results, number: %d" % i
        print >> sys.stderr, a_single_cmd_result
        break

if __name__ == "__main__":
    print "Calling main() in run.py"
    main()
